function img = LoadMBeamScan(fName, side)
%LOADMBEAMSCAN  - load U. W. Microbeam X-ray full scan as image
%
% 	usage:  img = LoadMBeamScan(fName, side)
%
% where FNAME specifies a square image of 16bit scan data 
% image SIDE length defaults to 300

% 07/98 mkt

order = 'b';			% byte order

if nargin < 1,
	eval('help LoadMBeamScan');
	return;
end;
if nargin < 2, side = 300; end;

%	load image

[fid, msg] = fopen(fName, 'rb', order);
if fid == -1							
	error([msg, ' (', fileName, ')']);
end;

img = fread(fid, [side side], 'int16')';
fclose(fid);

img = medfilt2(img);		% 3x3 median filtering to kill noise
