function m_cfgt(action, aux)
%M_CFGT  - MAVIS configure trajectory window support

%	branch by action...

switch action,

%-----------------------------------------------------------------------------
%	CLOSE:  trap close window requests

	case 'CLOSE',
		cfgState = get(gcbf, 'UserData');
		trajState = get(cfgState.TRAJWIN, 'UserData');
		state = get(trajState.GUI, 'UserData');
		if aux > 0,			% OK, apply

% scaling
			trajState.AUTOSCALE = get(cfgState.AUTORB, 'Value');
			if ~trajState.AUTOSCALE,
				v = str2num(get(cfgState.SPREADF, 'String'));
				if isempty(v) | v <= 0,
					set(gcbf, 'Visible', 'on');
					set(warndlg('specified spread is invalid', ''), 'WindowStyle', 'modal');
					return;
				else,
					trajState.SPREAD = v/2;
				end;
			end;

% framing trajectory
			names = state.DATA;
			names = char({names.NAME});
			trajState.FRAME = strmatch(get(cfgState.FRAMETRAJ, 'String'), names, 'exact');

% displayed trajectories
			dispNames = get(cfgState.DISPLAYED, 'String');
			trajState.DISPMAP = [];			
			for i = 1 : length(dispNames),
				trajState.DISPMAP(i) = strmatch(char(dispNames(i)), names, 'exact');
			end;
% if user chose to display nothing, set DISPMAP to framing trajectory
			if isempty(trajState.DISPMAP), trajState.DISPMAP = trajState.FRAME; end;
			trajState.SHOWTRAJ = [get(cfgState.SHOWSEL(1), 'Value'), get(cfgState.SHOWSEL(2), 'Value'), ...
									get(cfgState.SHOWSEL(3), 'Value'), get(cfgState.SHOWSEL(4), 'Value')];
		else,				% cancel
			trajState.AUTOSCALE = cfgState.SAVEAUTO;
			trajState.SPREAD = cfgState.SAVESPREAD;
			trajState.FRAME = cfgState.SAVEFRAME;
			trajState.DISPMAP = cfgState.SAVEMAP;
			trajState.SHOWTRAJ = cfgState.SAVESHOW;
			state.INTERP = cfgState.SAVEINTERP;
		end;
		set(cfgState.TRAJWIN, 'UserData', trajState);
		set(trajState.GUI, 'UserData', state);

		set(gcbf, 'Visible', 'off');
		m_traj('INIT', state, 1);
		m_spat('INIT', state);
		figure(cfgState.TRAJWIN);
		if aux<2, 
			delete(gcbf); 
		else,	
			set(gcbf, 'Visible', 'on'); 
		end;	

		
%-----------------------------------------------------------------------------
%	CHGDIR:  change xfer direction (aux > 0: loaded ==> displayed; < 0:  loaded <== displayed )

	case 'CHGDIR',
% double click sets framing trajectory
		if strcmp(get(gcbf, 'SelectionType'), 'open'),
			xi = get(gcbo, 'Value');		% selected indices
			if size(xi,2) == 1, 			% accept single selection only
				names = get(gcbo, 'String');
				cfgState = get(gcbf, 'UserData');
				set(cfgState.FRAMETRAJ, 'String', names(xi));
			end;
		end;

% set xfer direction
		xfer = get(gcbo, 'UserData');		% xfer button
		if get(xfer, 'UserData') == aux, return; end;	% already set
		if aux > 0,
			set(xfer, 'UserData', 1, 'String', '>');
		else,
			set(xfer, 'UserData', -1, 'String', '<');
		end;

		
		
%-----------------------------------------------------------------------------
%	INITialize

	case 'INIT',
		set(0,'ShowHiddenHandles', 'on');
		gui = findobj('Tag', 'GUI');
		set(0,'ShowHiddenHandles', 'off');
		state = get(gui, 'UserData');
		trajState = get(state.TRAJWIN, 'UserData');
		if ~trajState.INITIALIZED, return; end;
		figure(state.TRAJWIN);
		figPos = get(0, 'ScreenSize');
		width = 292;
		height = 270;
		figPos = [figPos(1)+(figPos(3)-width)/2, figPos(2)+(figPos(4)-height)/2, width, height];
		if strncmp(computer, 'SGI', 3), as = 'left'; else, as = 'right'; end;	% SGI bug:  doesn't like right alignment
		displayedIndex = trajState.DISPMAP;
		loadedIndex = setdiff([1:length(state.DATA)],displayedIndex);
		if isempty(loadedIndex),
			loadedNames = '';
		else,
			loadedNames = state.DATA(loadedIndex);
			loadedNames = cellstr(sortrows(char({loadedNames.NAME})));
		end;
		if isempty(displayedIndex),
			displayedNames = '';
		else,
			displayedNames = state.DATA(displayedIndex);
			displayedNames = {displayedNames.NAME};
		end;

		cfg = dialog('Name', 'Configure Trajectory Window', ...
			'Position', figPos, ...
			'ButtonDownFcn', '', ...
			'Tag', 'CONFIG', ...
			'CreateFcn', 'm_traj(''CURSOR'', ''HIDE'');', ...
			'DeleteFcn', 'm_traj(''CURSOR'', ''SHOW'');', ...
			'CloseRequestFcn', 'm_cfgt(''CLOSE'',0);');

		xfer = uicontrol(cfg, ... 	% xfer
			'Position',[137 203 20 20], ...
			'String','>', ...
			'UserData', 1, ...
			'Callback', 'm_cfgt XFER;');
			
		uicontrol(cfg, ...			% loaded
			'Style', 'text', ...
			'HorizontalAlignment','left', ...
			'String', 'Loaded', ...
			'Position', [30 242 70 17]);
		loaded = uicontrol(cfg, ...
			'Position',[20 185 100 56], ...
			'String', loadedNames, ...	
			'ListBoxTop', 1, ...
			'Style','listbox', ...
			'Max', 2, ...
			'Value', [], ...
			'UserData', xfer, ...
			'Callback', 'm_cfgt(''CHGDIR'',1);');
				
		uicontrol(cfg, ...			% displayed
			'Style', 'text', ...
			'HorizontalAlignment','left', ...
			'String', 'Displayed', ...
			'Position', [185 242 70 17]);
		displayed = uicontrol(cfg, ...
			'Position',[175 185 100 56], ...	
			'String', displayedNames, ...	
			'Style','listbox', ...
			'Max', 2, ...
			'Value', [], ...
			'UserData', xfer, ...
			'Callback', 'm_cfgt(''CHGDIR'',-1);');
					
		uicontrol(cfg, ...		% frame traj
			'Style', 'text', ...
			'HorizontalAlignment', as, ...
			'String', 'Framing Trajectory:', ...
			'Position', [5 153 110 17]);
		frameTraj = uicontrol(cfg, ...
			'Style', 'edit', ...
			'Enable', 'inactive', ...
			'HorizontalAlignment', 'left', ...
			'String', state.DATA(trajState.FRAME).NAME, ...
			'Position', [120 153 56 20]);
		if isunix, s = '(dbl click above)'; else, s = '(double click above)'; end;
		uicontrol(cfg, ...
			'Style', 'text', ...
			'HorizontalAlignment', 'left', ...
			'String', s, ...
			'Position', [181 153 105 17]);

		uicontrol(cfg, ...		% interpolation
			'Style', 'text', ...
			'HorizontalAlignment', as, ...
			'String', 'Interpolation:', ...
			'Position', [15 120 85 17]);
		uicontrol(cfg, ...
			'Position',[110 118 140 20], ...
			'HorizontalAlignment', 'left', ...
			'String','Nearest Neighbor|Linear|Cubic', ...
			'Style','popupmenu', ...
 			'Value', state.INTERP, ...
			'Callback', 'm_cfgt INTERP;');

		uicontrol(cfg, ...		% spread
			'Style', 'text', ...
			'HorizontalAlignment', as, ...
			'String', 'Scale:', ...
			'Position', [9 90 40 17]);
		if isunix, pos = [50 90 54 20]; else, pos = [55 90 50 20]; end;
		autoRB = uicontrol(cfg, ...
			'Position', pos, ...
			'String','Auto', ...
			'Style','radiobutton', ...
			'Value', trajState.AUTOSCALE, ...
			'Callback', 'set(gcbo,''Value'',1);set(get(gcbo,''UserData''),''Value'',~get(gcbo,''Value''));');
		if isunix, pos = [106 90 58 20]; else, pos = [110 90 50 20]; end;
		fixedRB = uicontrol(cfg, ...
			'Position', pos, ...
			'String','Fixed', ...
			'Style','radiobutton', ...
			'Value', ~trajState.AUTOSCALE, ...
			'UserData', autoRB, ...
			'Callback', 'set(gcbo,''Value'',1);set(get(gcbo,''UserData''),''Value'',~get(gcbo,''Value''));');
		set(autoRB, 'UserData', fixedRB);
		if isunix, pos = [165 90 50 17]; else, pos = [160 90 50 17]; end;
		uicontrol(cfg, ...
			'Style', 'text', ...
			'HorizontalAlignment', as, ...
			'String', 'Spread:', ...
			'Position', pos);
		spreadF = uicontrol(cfg, ...
			'Style', 'edit', ...
			'HorizontalAlignment', 'left', ...
			'Position', [215 90 60 20], ...
			'String', num2str(trajState.SPREAD*2));

		uicontrol(cfg, ...		% show
			'Style', 'text', ...
			'HorizontalAlignment', as, ...
			'String', 'Show:', ...
			'Position', [30 60 40 17]);
		showX = uicontrol(cfg, ...
			'Position', [75 60 40 20], ...
			'String','X', ...
			'Style','checkbox', ...
			'Value', trajState.SHOWTRAJ(1));
		showY = uicontrol(cfg, ...
			'Position', [120 60 40 20], ...
			'String','Y', ...
			'Style','checkbox', ...
			'Value', trajState.SHOWTRAJ(2));
		showZ = uicontrol(cfg, ...
			'Position', [165 60 40 20], ...
			'String','Z', ...
			'Style','checkbox', ...
			'Value', trajState.SHOWTRAJ(3));
		showO = uicontrol(cfg, ...
			'Position', [210 60 63 20], ...
			'String','other', ...
			'Style','checkbox', ...
			'Value', trajState.SHOWTRAJ(4));

		uicontrol(cfg, ...		% buttons
			'Position',[35 15 60 25], ...
			'String','OK', ...
			'Callback','m_cfgt(''CLOSE'',1);');
		uicontrol(cfg, ...
			'Position',[115 15 60 25], ...
			'String','Apply', ...
			'Callback','m_cfgt(''CLOSE'',2);');
		uicontrol(cfg, ...
			'Position',[195 15 60 25], ...
			'String','Cancel', ...
			'Callback','m_cfgt(''CLOSE'',0);');

		cfgState = struct('TRAJWIN', state.TRAJWIN, ...
					'AUTORB', autoRB, ...
					'SPREADF', spreadF, ...
					'LOADED', loaded, ...
					'DISPLAYED', displayed, ...
					'FRAMETRAJ', frameTraj, ...
					'SHOWSEL', [showX showY showZ showO], ...
					'SAVEAUTO', trajState.AUTOSCALE, ...
					'SAVESPREAD', trajState.SPREAD, ...
					'SAVEFRAME', trajState.FRAME, ...
					'SAVEMAP', trajState.DISPMAP, ...
					'SAVESHOW', trajState.SHOWTRAJ, ...
					'SAVEINTERP', state.INTERP);
		set(cfg, 'UserData', cfgState);

		
%-----------------------------------------------------------------------------
%	INTERP:  set interpolation method

	case 'INTERP',
		cfgState = get(gcbf, 'UserData');
		trajState = get(cfgState.TRAJWIN, 'UserData');
		state = get(trajState.GUI, 'UserData');
		state.INTERP = get(gcbo, 'Value');
		set(trajState.GUI, 'UserData', state);
		
		
%-----------------------------------------------------------------------------
%	TOGGLE:  process radio button update

	case 'TOGGLE',
		set(get(gcbo, 'UserData'), 'Value', ~get(gcbo, 'Value'));
	
	
%-----------------------------------------------------------------------------
%	XFER:  transfer list elements

	case 'XFER',
% transfer selected items between lists
		cfgState = get(gcbf, 'UserData');
		xferDir = get(gcbo, 'UserData');
		if xferDir > 0,
			fromH = cfgState.LOADED;
			toH = cfgState.DISPLAYED;
		else,
			fromH = cfgState.DISPLAYED;
			toH = cfgState.LOADED;
		end;
		xi = get(fromH, 'Value');	% selected indices
		fromList = cellstr(get(fromH, 'String'));
		if isempty(fromList), return; end;
		toList = cellstr(get(toH, 'String'));
		ki = setdiff([1:length(fromList)], xi);
		if isempty(toList{1}),
			toList = fromList(xi);
		else,
			toList = [toList ; fromList(xi)];
		end;
		if isempty(ki),
			fromList = [];
		else,
			fromList = fromList(ki);
		end;
		if xferDir > 0,
			if ~isempty(fromList), fromList = cellstr(sortrows(char(fromList))); end;
		else,
			if ~isempty(toList), toList = cellstr(sortrows(char(toList))); end;
		end;
		set(fromH, 'String', fromList, 'Value', []);
		set(toH, 'String', toList, 'Value', []);

	
%-----------------------------------------------------------------------------
%	error

	otherwise,
		error(['M_CFGT:  unrecognized action (', action, ')']);
	
end;
